<template>
  <div class="container container-with-menu">
    <div class="row">
      <h1><siren-icon />Gérer les entreprises</h1>
    </div>
    <p>
      Veuillez renseigner ici la liste des entreprises pour lesquelles vous souhaitez ajouter des fichiers DSN.<br>
      <u>Remarque</u> : Un fichier DSN dont l'entreprise n’aura pas été déclarée dans cette étape ne pourra pas être importé.
    </p>
    <hr>
    <div class="row">
      <div class="col-xs-12 col-md-8 col-md-offset-2 col-lg-6 col-lg-offset-3">
        <form
          id="newSirenForm"
          novalidate="novalidate"
        >
          <div class="form-group required">
            <label
              for="name"
            >Entreprise&nbsp;:</label>
            <input
              id="name"
              v-model="name"
              name="entreprise"
              type="text"
              minlength="2"
              class="form-control"
              required="required"
            >
          </div>
          <div class="form-group required">
            <label
              for="number"
            >Numéro SIREN :
              <i
                style="color: gray"
                class="fa fa-question-circle-o fa-fw"
                data-toggle="tooltip"
                data-placement="right"
                title="Le numéro SIREN à 9 chiffres est le numéro d'identification unique des entreprises. L'INSEE le délivre lorsque l'on immatricule une entreprise au registre national des entreprises. Ce numéro ne doit pas être confondu avec le numéro SIRET à 14 chiffres composé du SIREN + un code établissement à 5 chiffres (une entreprise n'a qu'un SIREN et peut avoir plusieurs SIRET : 1 par établissement)."
              />
            </label>
            <input
              id="number"
              v-model="number"
              name="number"
              type="number"
              minlength="9"
              maxlength="9"
              class="form-control"
              required="required"
            >
          </div>
          <div class="form-group required">
            <label
              for="maxPersonnelNumbers"
            >Effectif mensuel maximum :
              <i
                style="color: gray"
                class="fa fa-question-circle-o fa-fw"
                data-toggle="tooltip"
                data-placement="right"
                title="Merci de renseigner le nombre maximum de matricules qui peuvent être présent dans une de vos DSN mensuels.
Remarque : Si vous avez plus de matricule dans l’une de vos DSN mensuel que le chiffre indiqué votre fichier DSN sera rejeté."
              />
            </label>
            <input
              id="maxPersonnelNumbers"
              v-model="maxPersonnelNumbers"
              name="maxPersonnelNumbers"
              type="number"
              minlength="1"
              class="form-control"
              required="required"
            >
          </div>
          <div
            v-if="editionMode===false"
            class="form-group btn-list"
          >
            <click-button
              :disabled="isLoading || name.length === 0 || number.length === 0 || maxPersonnelNumbers.length === 0"
              @click="add()"
            >
              <template slot="content">
                Ajouter le SIREN
              </template>
            </click-button>
          </div>
          <div
            v-if="editionMode===true"
            class="form-group btn-list"
          >
            <click-button
              :disabled="isLoading"
              @click="confirmUpdateSiren()"
            >
              <template #content>
                Mettre à jour
              </template>
            </click-button>
            <click-button
              :disabled="isLoading"
              @click="resetSiren()"
            >
              <template #content>
                Annuler
              </template>
            </click-button>
          </div>
        </form>
      </div>
    </div>
    <siren-table
      :edition-mode="editionMode"
      @edit="editSiren"
    />
    <first-siren-added-modal
      v-if="isFirstSirenJustAdded===true"
      @okClicked="next"
    />
    <confirmation-modal-edit
      id="confirmationModalEdit"
      text="Êtes-vous sûr de vouloir éditer cette entreprise ?"
      @okClicked="performUpdateSiren"
    />
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
import VanillaToasts from 'vanillatoasts'
import FirstSirenAddedModal from '../../../components/Modal/FirstSirenAddedModal'
import SirenIcon from "../../../components/Icon/SirenIcon";
import ClickButton from "../../../components/Button/ClickButton";
import SirenTable from "./SirenTable";
import ConfirmationModalEdit from "../../../components/Modal/ConfirmationModal";

export default {
  name: 'SirenList',
  components: {
    SirenTable,
    ClickButton,
    SirenIcon,
    FirstSirenAddedModal,
    ConfirmationModalEdit,
  },
  data() {
    return {
      validator: null,
      id: 0,
      name: '',
      number: '',
      maxPersonnelNumbers: '',
      editionMode: false,
      editedSirenIndex: null,
      isFirstSirenJustAdded:false,
    }
  },
  computed: {
    ...mapGetters([
      'sirens',
      'isLoading',
      'user',
      'isFirstSirenAdded',
    ])
  },
  created () {
    this.fetchSirens()
  },
  mounted() {
    $(function () {
      $('[data-toggle="tooltip"]').tooltip()
    })
    this.validator = $('#newSirenForm').submit(function (e) {
      e.preventDefault();
    }).validate({
      rules: {
        name: {
          required: true,
        },
        number: {
          required: true,
          maxlength: 9,
          minlength: 9,
          digits: true
        },
        maxPersonnelNumbers: {
          required: true,
          minlength: 1,
          digits: true
        }
      },
      errorElement: 'em',
      errorPlacement: function (error, element) {
        // Add the `help-block` class to the error element
        error.addClass('help-block');

        if (element.prop("type") === 'checkbox') {
          error.insertAfter(element.parent('label'));
        } else {
          error.insertAfter(element);
        }
      },
      highlight: function (element) {
        $(element).parents(".form-group").addClass("has-error").removeClass("has-success");
      },
      unhighlight: function (element) {
        $(element).parents(".form-group").addClass("has-success").removeClass("has-error");
      }
    });
  },
  methods: {
    ...mapActions([
      'fetchSirens',
      'createSiren',
      'updateSiren',
      'loadingStarts',
      'loadingEnds',
      'firstSirenAdded',
    ]),
    confirmUpdateSiren() {
      $('#confirmationModalEdit').modal({keyboard:false,backdrop:'static'})
    },
    performUpdateSiren() {
      if ($("#newSirenForm").valid()) {
        this.updateSiren({
          id: parseInt(this.id),
          name: this.name,
          number: parseInt(this.number),
          maxPersonnelNumbers: parseInt(this.maxPersonnelNumbers)
        }).then(()=>{
          VanillaToasts.create({
            title: 'Modification SIREN',
            text: 'Opération effectuée avec succès',
            type: 'success',
            timeout: 5000,
          });
          this.resetSiren()
        })
      }
    },
    add() {
      this.validator.resetForm();
      if ($("#newSirenForm").valid()) {
        this.loadingStarts()

        this.createSiren({
          number: parseInt(this.number),
          maxPersonnelNumbers: parseInt(this.maxPersonnelNumbers),
          name: this.name
        }).then(()=>{
          this.resetSiren()
          VanillaToasts.create({
            title: 'Ajout SIREN',
            text: 'Opération effectuée avec succès',
            type: 'success',
            timeout: 5000, // hide after 5000ms, // optional paremter
          });
          this.loadingEnds()
          if(this.sirens.length===1&&this.user.wizard.isFirstSirenAdded===false) {
            this.firstSirenAdded().then(()=>{
              this.isFirstSirenJustAdded = true
            })
          }
        })
      }
    },
    editSiren(siren) {
      this.editionMode = true
      this.editedSirenIndex = siren.index
      this.id = siren.id
      this.name = siren.name
      this.number = siren.number
      this.maxPersonnelNumbers = siren.maxPersonnelNumbers
      $('html,body').scrollTop(0)
    },
    resetSiren() {
      this.editedSirenIndex = null
      this.editionMode = false
      this.number = ''
      this.maxPersonnelNumbers = ''
      this.name = ''
    },
    next() {
      this.$router.push({ path: '/fichiers-dsn' })
    }
  }
}
</script>

<style scoped>

</style>